
require "amrita/template"
require "profiler"

tmpl = Amrita::TemplateText.new "<html></html>"
s = ""
Profiler__.start_profile
tmpl.expand(s, {})
Profiler__.print_profile($stdout)

=begin
Amrita 1.8.2 s
  %   cumulative   self              self     total
 time   seconds   seconds    calls  ms/call  ms/call  name
161.54     0.42      0.42        1   420.00   420.00  Profiler__.start_profile
 19.23     0.47      0.05        2    25.00    30.00  Amrita::HtmlScanner#generate_tag
 11.54     0.50      0.03        3    10.00    10.00  Amrita::NullNode#==
  3.85     0.51      0.01        1    10.00    10.00  Amrita::ByteCode::PrintStaticNode#[]
  3.85     0.52      0.01        1    10.00    10.00  Amrita::Node.to_node
  3.85     0.53      0.01        1    10.00    70.00  Amrita::Template#setup_vm
  3.85     0.54      0.01        1    10.00    10.00  Amrita::AttrArrayCommon.size
  3.85     0.55      0.01        3     3.33    26.67  Kernel.loop
  3.85     0.56      0.01        1    10.00    10.00  Amrita::ByteCodeCommon::Instruction.prepare
  3.85     0.57      0.01        1    10.00    10.00  Amrita::InstructionSet#compile
  3.85     0.58      0.01        1    10.00    80.00  Amrita::Node.init_body
  3.85     0.59      0.01        2     5.00     5.00  Amrita::HtmlScanner#state_text
  3.85     0.60      0.01        2     5.00    20.00  Amrita::Node.no_child?
  3.85     0.61      0.01        1    10.00    10.00  Amrita::HtmlParser#initialize
  3.85     0.62      0.01        3     3.33     3.33  String#intern
  3.85     0.63      0.01        1    10.00    30.00  Amrita::ElementCommon.convert_to_bytecode
  3.85     0.64      0.01        2     5.00     5.00  Amrita::TagInfo#get_tag_info
  3.85     0.65      0.01        1    10.00    10.00  Amrita::InstructionSet#execute
  3.85     0.66      0.01        2     5.00     5.00  Amrita::Tag#start_tag?
  3.85     0.67      0.01        1    10.00    10.00  Amrita::Compiler#make_defaults
  0.00     0.67      0.00        1     0.00    50.00  Amrita::ByteCodeCommon::PrintStaticNode.prepare
  0.00     0.67      0.00        1     0.00     0.00  Amrita::InstructionSet#new_seqno
  0.00     0.67      0.00       10     0.00     0.00  String#gsub!
  0.00     0.67      0.00        1     0.00    40.00  Amrita::ElementProcessorCommon.format_node
  0.00     0.67      0.00        5     0.00     0.00  String#downcase
  0.00     0.67      0.00        1     0.00    10.00  Amrita::Element#set_tag
  0.00     0.67      0.00        1     0.00     0.00  Amrita::ByteCodeCommon::Instruction.set_seqno
  0.00     0.67      0.00        1     0.00     0.00  Amrita::AttrArray#initialize
  0.00     0.67      0.00        1     0.00     0.00  Module#module_eval
  0.00     0.67      0.00        1     0.00     0.00  Amrita::ElementCommon.simple_span?
  0.00     0.67      0.00        1     0.00     0.00  Amrita::TemplateText#need_update?
  0.00     0.67      0.00        1     0.00     0.00  Amrita::ElementProcessor#escaped_id=
  0.00     0.67      0.00        1     0.00     0.00  Range#each
  0.00     0.67      0.00        1     0.00    30.00  Amrita::Compiler#compile
  0.00     0.67      0.00        1     0.00   130.00  Amrita::HtmlParser#parse_text
  0.00     0.67      0.00        1     0.00     0.00  #<Module:0x402c11d4>.execute
  0.00     0.67      0.00        7     0.00     0.00  Hash#[]
  0.00     0.67      0.00        1     0.00    10.00  Amrita::Node.has_id_element?
  0.00     0.67      0.00        2     0.00     0.00  Module#extend_object
  0.00     0.67      0.00        1     0.00     0.00  Amrita::ElementProcessor#initialize
  0.00     0.67      0.00        2     0.00     0.00  Hash#has_key?
  0.00     0.67      0.00        1     0.00     0.00  Array#join
  0.00     0.67      0.00        1     0.00     0.00  Amrita::ElementProcessorCommon.taginfo_of_element
  0.00     0.67      0.00        1     0.00     0.00  Kernel.instance_eval
  0.00     0.67      0.00        1     0.00   260.00  #toplevel
  0.00     0.67      0.00        1     0.00   120.00  Amrita::HtmlParser#parse
  0.00     0.67      0.00        1     0.00     0.00  Amrita::VirtualMachine#initialize
  0.00     0.67      0.00        1     0.00     0.00  Amrita::Tag#accept_child
  0.00     0.67      0.00       18     0.00     6.11  Class#new
  0.00     0.67      0.00        6     0.00    11.67  Method#call
  0.00     0.67      0.00        6     0.00     0.00  StringScanner#pointer
  0.00     0.67      0.00        1     0.00     0.00  Amrita::InstructionSet#initialize
  0.00     0.67      0.00        1     0.00     0.00  Amrita::ByteCode::Instruction#prepare
  0.00     0.67      0.00        4     0.00     0.00  Amrita::AttrArrayCommon.value_by_key
  0.00     0.67      0.00        2     0.00     0.00  Kernel.extend
  0.00     0.67      0.00        1     0.00     0.00  Amrita::ElementProcessor#amrita_id=
  0.00     0.67      0.00        9     0.00     0.00  Amrita::Pragma::UncertainData#add_candidate
  0.00     0.67      0.00        1     0.00     0.00  String#==
  0.00     0.67      0.00        1     0.00    10.00  Amrita::ElementProcessorCommon.format_single_tag
  0.00     0.67      0.00        1     0.00    10.00  Amrita::Template#setup_compiler
  0.00     0.67      0.00        1     0.00    60.00  Amrita::VirtualMachine#load_bytecode
  0.00     0.67      0.00        7     0.00     0.00  Fixnum#>
  0.00     0.67      0.00        2     0.00     0.00  Enumerable.collect
  0.00     0.67      0.00        1     0.00    60.00  Amrita::InstructionSet#prepare
  0.00     0.67      0.00        1     0.00     0.00  StringScanner#initialize
  0.00     0.67      0.00        1     0.00     0.00  Symbol#to_s
  0.00     0.67      0.00        2     0.00    30.00  Amrita::HtmlScanner#state_space
  0.00     0.67      0.00        1     0.00   130.00  Amrita::TemplateText#load_template
  0.00     0.67      0.00        2     0.00     0.00  Amrita::AttrArray#<<
  0.00     0.67      0.00        8     0.00     0.00  StringScanner#empty?
  0.00     0.67      0.00        9     0.00     0.00  Array#<<
  0.00     0.67      0.00        1     0.00     0.00  Amrita::Template#get_parser_class
  0.00     0.67      0.00        1     0.00     0.00  Amrita::Pragma::UncertainData#initialize
  0.00     0.67      0.00        1     0.00    10.00  Amrita::VirtualMachine#go
  0.00     0.67      0.00        2     0.00     0.00  Amrita::HtmlScanner#state_tagname
  0.00     0.67      0.00        1     0.00   250.00  Amrita::Template#expand
  0.00     0.67      0.00        1     0.00    90.00  Amrita::ElementProcessorCommon.generate_element
  0.00     0.67      0.00        1     0.00   170.00  Amrita::Template#setup_template
  0.00     0.67      0.00        2     0.00     0.00  Amrita::ElementCommon.amrita_id
  0.00     0.67      0.00        1     0.00     0.00  Hash#[]=
  0.00     0.67      0.00        3     0.00     0.00  Hash#default
  0.00     0.67      0.00       13     0.00     0.00  Array#each
  0.00     0.67      0.00        3     0.00     0.00  Amrita::Set#include?
  0.00     0.67      0.00        6     0.00     0.00  StringScanner#scan
  0.00     0.67      0.00        6     0.00     0.00  Kernel.===
  0.00     0.67      0.00        6     0.00     0.00  Amrita::AttrArrayCommon.each
  0.00     0.67      0.00        1     0.00     0.00  Kernel.respond_to?
  0.00     0.67      0.00        4     0.00     0.00  Symbol#intern
  0.00     0.67      0.00        2     0.00     0.00  String#inspect
  0.00     0.67      0.00        3     0.00     0.00  Amrita::Tag#empty_tag?
  0.00     0.67      0.00        1     0.00    90.00  Amrita::HtmlParser#generate_element
  0.00     0.67      0.00        2     0.00     0.00  Amrita::ByteCodeCommon::PrintBase.ruby_code
  0.00     0.67      0.00        5     0.00     0.00  Kernel.kind_of?
  0.00     0.67      0.00        1     0.00    10.00  Amrita::ElementProcessorCommon.format_attrs
  0.00     0.67      0.00        1     0.00   240.00  Amrita::Template#setup
  0.00     0.67      0.00        6     0.00     0.00  Fixnum#==
  0.00     0.67      0.00        1     0.00     0.00  Amrita::HtmlScanner#empty?
  0.00     0.67      0.00        1     0.00     0.00  Hash#each
  0.00     0.67      0.00        3     0.00     0.00  Amrita::Tag#initialize
  0.00     0.67      0.00        1     0.00     0.00  Amrita::ByteCode::PrintStaticNode#initialize
  0.00     0.67      0.00        2     0.00     0.00  Amrita::VirtualMachine#debug=
  0.00     0.67      0.00        2     0.00     0.00  String#downcase!
  0.00     0.67      0.00        1     0.00     0.00  Amrita::HtmlScanner#initialize
  0.00     0.67      0.00        1     0.00    10.00  Amrita::Template#do_expand
  0.00     0.67      0.00        5     0.00     0.00  Array#size
  0.00     0.67      0.00        1     0.00     0.00  Amrita::TagInfo#get_tag_info2
  0.00     0.67      0.00        1     0.00    10.00  Amrita::Node.children
  0.00     0.67      0.00        1     0.00    90.00  Amrita::Element#initialize
  0.00     0.67      0.00        2     0.00     0.00  Object#initialize
  0.00     0.67      0.00        6     0.00     0.00  StringScanner#skip
  0.00     0.67      0.00        1     0.00     0.00  Amrita::Template#setup_ep
  0.00     0.67      0.00        3     0.00    26.67  Amrita::HtmlScanner#scan
  0.00     0.67      0.00        1     0.00     0.00  Amrita::ByteCodeCommon::Instruction.define_execute
  0.00     0.67      0.00        1     0.00     0.00  Module#initialize
  0.00     0.67      0.00        3     0.00     0.00  String#[]
  0.00     0.67      0.00        2     0.00    90.00  Amrita::HtmlParser#parse1
  0.00     0.67      0.00        1     0.00     0.00  String#<<
  0.00     0.67      0.00        1     0.00     0.00  Amrita::NullNode#+
  0.00     0.67      0.00        1     0.00    10.00  Amrita::Compiler#initialize
  0.00     0.67      0.00       18     0.00     0.00  Module#===
  0.00     0.67      0.00        7     0.00     0.00  Kernel.method
  0.00     0.67      0.00        9     0.00     0.00  Kernel.==
  0.00     0.67      0.00        3     0.00     0.00  Fixnum#+
  0.00     0.67      0.00        2     0.00     0.00  Hash#size
  0.00     0.67      0.00        1     0.00     0.00  Amrita::ByteCode::Instruction#initialize
  0.00     0.67      0.00        2     0.00     0.00  String#size
  0.00     0.67      0.00        2     0.00     0.00  Amrita::ElementCommon.get_expandable_attrs
  0.00     0.67      0.00        4     0.00     0.00  Amrita::ElementCommon.[]
  0.00     0.67      0.00        2     0.00     0.00  Kernel.singleton_method_added
  0.00     0.67      0.00        2     0.00     0.00  Fixnum#-
  0.00     0.67      0.00        3     0.00     0.00  Kernel.block_given?
  0.00     0.67      0.00        1     0.00     0.00  Amrita::TagInfo::TagInfoItem#initialize
  0.00     0.67      0.00        1     0.00    10.00  Amrita::Node.each_node
  0.00     0.67      0.00        4     0.00     0.00  String#to_s

Amrita 1.0.2 s
  %   cumulative   self              self     total
 time   seconds   seconds    calls  ms/call  ms/call  name
145.00     0.29      0.29        1   290.00   290.00  Profiler__.start_profile
 15.00     0.32      0.03        1    30.00    30.00  Amrita::NullNode#format
 10.00     0.34      0.02        1    20.00    70.00  Amrita::Tag#generate_element
  5.00     0.35      0.01        1    10.00    30.00  Amrita::Node.expand
  5.00     0.36      0.01        3     3.33     3.33  Amrita::AttrArray#initialize
  5.00     0.37      0.01        3     3.33     3.33  Amrita::Node.to_node
  5.00     0.38      0.01        2     5.00    10.00  Amrita::HtmlScanner#state_tagname
  5.00     0.39      0.01        9     1.11     1.11  Kernel.block_given?
  5.00     0.40      0.01        2     5.00    25.00  Amrita::Element#initialize
  5.00     0.41      0.01        4     2.50     5.00  Amrita::TagInfo#get_tag_info
  5.00     0.42      0.01       14     0.71     0.71  Module#===
  5.00     0.43      0.01       13     0.77     5.38  Class#new
  5.00     0.44      0.01        1    10.00    10.00  Amrita::Template#get_parser_class
  5.00     0.45      0.01        6     1.67     8.33  Method#call
  5.00     0.46      0.01        3     3.33    20.00  Kernel.loop
  5.00     0.47      0.01        6     1.67     1.67  StringScanner#skip
  5.00     0.48      0.01        7     1.43     1.43  Fixnum#==
  5.00     0.49      0.01        2     5.00    75.00  Amrita::HtmlParser#parse1
  0.00     0.49      0.00        1     0.00     0.00  Hash#[]=
  0.00     0.49      0.00        4     0.00     0.00  Hash#has_key?
  0.00     0.49      0.00        6     0.00     0.00  Array#each
  0.00     0.49      0.00        1     0.00   120.00  Amrita::TemplateText#load_template
  0.00     0.49      0.00        1     0.00     0.00  Amrita::NullNode#expand1
  0.00     0.49      0.00        1     0.00     0.00  Amrita::Template#setup_formatter
  0.00     0.49      0.00        3     0.00     0.00  String#intern
  0.00     0.49      0.00        1     0.00     0.00  Amrita::Tag#accept_child
  0.00     0.49      0.00        7     0.00     0.00  Kernel.method
  0.00     0.49      0.00        3     0.00     0.00  Amrita::Tag#empty_tag?
  0.00     0.49      0.00        6     0.00     0.00  Array#size
  0.00     0.49      0.00        2     0.00    25.00  Amrita::Node.init_body
  0.00     0.49      0.00        1     0.00   110.00  Amrita::HtmlParser#parse_text
  0.00     0.49      0.00        1     0.00     0.00  Amrita::NullNode#+
  0.00     0.49      0.00        2     0.00     0.00  Amrita::Element#[]
  0.00     0.49      0.00        1     0.00     0.00  Amrita::TagInfo::TagInfoItem#initialize
  0.00     0.49      0.00        1     0.00     0.00  Amrita::Node.no_child?
  0.00     0.49      0.00        1     0.00     0.00  Amrita::Element#clone
  0.00     0.49      0.00        2     0.00    10.00  Amrita::HtmlScanner#state_space
  0.00     0.49      0.00        2     0.00     0.00  Amrita::HtmlScanner#state_text
  0.00     0.49      0.00        5     0.00     0.00  Hash#default
  0.00     0.49      0.00        1     0.00    50.00  Amrita::Formatter#format
  0.00     0.49      0.00        1     0.00    50.00  Amrita::AsIsFormatter#format_element
  0.00     0.49      0.00        1     0.00     0.00  Amrita::NullNode#clone
  0.00     0.49      0.00        1     0.00     0.00  Amrita::Template#setup_context
  0.00     0.49      0.00        2     0.00     0.00  String#<<
  0.00     0.49      0.00        1     0.00     0.00  Amrita::HtmlScanner#initialize
  0.00     0.49      0.00        1     0.00     0.00  Amrita::Formatter#format_end_tag
  0.00     0.49      0.00        1     0.00   120.00  Amrita::Template#setup_template
  0.00     0.49      0.00        2     0.00     5.00  Amrita::Tag#start_tag?
  0.00     0.49      0.00        1     0.00     0.00  Amrita::TemplateText#need_update?
  0.00     0.49      0.00        1     0.00    10.00  Amrita::Element#delete_attr!
  0.00     0.49      0.00        1     0.00     0.00  Kernel.clone
  0.00     0.49      0.00        1     0.00    20.00  Amrita::DictionaryData.amrita_expand_element
  0.00     0.49      0.00        1     0.00   200.00  #toplevel
  0.00     0.49      0.00       10     0.00     0.00  String#gsub!
  0.00     0.49      0.00        2     0.00     0.00  String#downcase!
  0.00     0.49      0.00        2     0.00     0.00  Symbol#id2name
  0.00     0.49      0.00        1     0.00     0.00  Amrita::Template#setup_parser_filter
  0.00     0.49      0.00        2     0.00    50.00  Amrita::Formatter#with_stream
  0.00     0.49      0.00        1     0.00     0.00  Kernel.kind_of?
  0.00     0.49      0.00        1     0.00     0.00  Kernel.=~
  0.00     0.49      0.00        1     0.00   110.00  Amrita::HtmlParser#parse
  0.00     0.49      0.00        2     0.00     0.00  Amrita::Template#setup_taginfo
  0.00     0.49      0.00        1     0.00     0.00  Array#collect
  0.00     0.49      0.00        2     0.00     0.00  String#size
  0.00     0.49      0.00        1     0.00     0.00  Amrita::Formatter#format_attrs
  0.00     0.49      0.00        1     0.00     0.00  Amrita::Formatter#initialize
  0.00     0.49      0.00        6     0.00     0.00  StringScanner#scan
  0.00     0.49      0.00        3     0.00     0.00  String#[]
  0.00     0.49      0.00        1     0.00     0.00  Amrita::HtmlScanner#empty?
  0.00     0.49      0.00        1     0.00    80.00  Amrita::Template#do_expand
  0.00     0.49      0.00        1     0.00     0.00  Amrita::Formatter#format_start_tag
  0.00     0.49      0.00        4     0.00     0.00  Amrita::Element#tagname_symbol
  0.00     0.49      0.00        5     0.00     0.00  String#downcase
  0.00     0.49      0.00        8     0.00     0.00  Hash#[]
  0.00     0.49      0.00        1     0.00     0.00  Amrita::Element#set_tag
  0.00     0.49      0.00        8     0.00     0.00  StringScanner#empty?
  0.00     0.49      0.00        3     0.00     0.00  Amrita::Tag#initialize
  0.00     0.49      0.00        1     0.00     0.00  Amrita::AttrArray#size
  0.00     0.49      0.00        2     0.00    10.00  Amrita::HtmlScanner#generate_tag
  0.00     0.49      0.00        1     0.00     0.00  String#==
  0.00     0.49      0.00        1     0.00    10.00  Amrita::Formatter#taginfo_of_element
  0.00     0.49      0.00        1     0.00    20.00  Amrita::Element#expand1
  0.00     0.49      0.00        3     0.00     0.00  Symbol#intern
  0.00     0.49      0.00        3     0.00    20.00  Amrita::HtmlScanner#scan
  0.00     0.49      0.00        1     0.00     0.00  Amrita::HtmlParser#initialize
  0.00     0.49      0.00       11     0.00     0.00  Kernel.===
  0.00     0.49      0.00        2     0.00     0.00  Fixnum#+
  0.00     0.49      0.00        1     0.00     0.00  Proc#call
  0.00     0.49      0.00        1     0.00   200.00  Amrita::Template#expand
  0.00     0.49      0.00        1     0.00    10.00  Amrita::Formatter#can_be_single?
  0.00     0.49      0.00        1     0.00    10.00  Amrita::ExpandContext#filter_element
  0.00     0.49      0.00        6     0.00     0.00  StringScanner#pointer
  0.00     0.49      0.00        1     0.00     0.00  StringScanner#initialize
  0.00     0.49      0.00        5     0.00     0.00  Fixnum#>
  0.00     0.49      0.00        2     0.00     0.00  Amrita::Element#tagname
  0.00     0.49      0.00        2     0.00     0.00  Amrita::AttrArray#each
  0.00     0.49      0.00        2     0.00     0.00  Fixnum#-
  0.00     0.49      0.00       14     0.00     0.00  Kernel.==
  0.00     0.49      0.00        1     0.00     0.00  Kernel.initialize_copy
  0.00     0.49      0.00        1     0.00    50.00  Amrita::Element#format
  0.00     0.49      0.00        1     0.00    10.00  Amrita::Element#copy_on_write
  0.00     0.49      0.00        1     0.00     0.00  Amrita::Element#hid
  0.00     0.49      0.00        3     0.00     0.00  Amrita::Set#include?
=end
