
require "amrita/template"

# Υ饹Υ֥ȤϡSGMLʸǤȤ롣
# ƥǥ뤴Ȥ˰㤦饹ˤ롣
class MyTagClass
  attr_reader :name

  def initialize(name, attrs)
    print "name = #{name}, id = #{__id__}\n"  # DEBUG
    @name = name
    @attrs = attrs
  end

  def empty_tag?
    false
  end

  def start_tag?
    if @name == "html"
      return true
    elsif @name == "p"
      return true
    elsif @name == "tr"
      return true
    elsif @name == "td"
      return true
    else
      false
    end
  end

  def can_omit_endtag?
    true
  end

  # child_tagǤȤ뤫
  # child_tagޤळȤǤʤȤϵ֤褦ˤ롣
  def accept_child(child_tag)
    if @name == "p"
      if child_tag == "p"
        return false 
      end
    elsif @name == "td"
      if child_tag == "td" || child_tag == "tr"
        return false
      end
    elsif @name == "tr"
      if child_tag == "tr"
        return false
      end
    end
    return true
  end

  # Amrita::ElementޤAmrita::pre֤褦ˤ롣
  def generate_element(parser)
    a = @attrs.collect {|attr| Attr.new(attr[0], attr[1])}
    return Amrita::Element.new(@name, *a) {parser.parse1(self)}
  end
end

class MyInfoItem
  def tag_class
    print "tag_class()\n"   # DEBUG
    return MyTagClass
  end
end

# ޤ륯饹
# ֥Ȥget_tag_info()Ĥȡ
class MyTagInfo
  def initialize
    @item = MyInfoItem.new
  end

  # tag_class()ĥ֥Ȥ֤褦ˤ
  def get_tag_info(tagname)
    print "get_tag_info()\n"    # DEBUG
    return @item
  end
end

=begin
ѡǤϡHtmlScanner#generate_tag()ˤơΥɤˤʤäƤ

  ǰİĤˤĤơ
      klass = @taginfo.get_tag_info(@tagname).tag_class || Tag
      ret = klass.new(@tagname, @attrs)

  2003.12.08 ̣롣
    - generate_element()ѡ˰¸Ƥ
    - InfoItemĹ
    - ۤΥ󥯥饹Tag˥ѡ¸Ƥ

  generate_tag() Ǥϡget_tag_info()nil֤㳰ꤲ٤ޤǥǥեȥ饹Ѱդ٤

=end

def test2
  r = Amrita::HtmlParser.parse_text(<<EOF, nil, 0, MyTagInfo.new)
<tr><td>foo<td>bar<tr><td>hoge
EOF
  p r
end

test2()

=begin
Amrita 1.0.2 Ǥμ¹Է:

get_tag_info()
tag_class()
name = tr, id = 538213882
get_tag_info()
tag_class()
name = td, id = 538213362
get_tag_info()
tag_class()
name = td, id = 538212772
get_tag_info()
tag_class()
name = tr, id = 538212112
get_tag_info()
tag_class()
name = td, id = 538211402
[ e(:tr) { [ e(:td) { "foo" }, e(:td) { "bar" } ] }, e(:tr) { e(:td) { "hoge\n" } } ]
=end
