

require "~/src/classinspect-current/classinspect.rb"
require "amrita/template"

make_tree(
%w(
  Object
  TrueClass
  NilClass
  FalseClass
  String
  Proc
  Hash
  Enumerable
  Amrita
  Amrita::DictionaryData
  Amrita::ExpandByMember
  Amrita::Node
  Amrita::ModelMisMatch
  Amrita::ExpandContext
  Amrita::AttrArray
  Amrita::NullNode
  Amrita::Element
  Amrita::NodeArray
  Amrita::FormatterNode
  Amrita::SanitizedString
  Amrita::TextElement
  Amrita::SpecialElement
  Amrita::Escape
  Amrita::HtmlParser
  Amrita::HtmlScanner
  Amrita::HtmlParseError
  Amrita::TagInfo
  Amrita::HtmlTagInfo
))


=begin

Amrita
Object
    Amrita::AttrArray
    Amrita::Element
    Amrita::ExpandContext
    Amrita::FormatterNode
    Amrita::NodeArray
    Amrita::NullNode
    FalseClass
    Hash
    NilClass
    Proc
    String
    TrueClass
Amrita::DictionaryData
Amrita::ExpandByMember
RuntimeError
    Amrita::ModelMisMatch
Amrita::Node
Enumerable
hori@orange
~/ruby/amrita$ ruby class_tree.rb
Amrita
Object
    Amrita::AttrArray
    Amrita::Element
    Amrita::ExpandContext
    Amrita::FormatterNode
        Amrita::Escape
    Amrita::HtmlParser
    Amrita::HtmlScanner
    Amrita::NodeArray
    Amrita::NullNode
    Amrita::SpecialElement
    Amrita::TagInfo
        Amrita::HtmlTagInfo
    Amrita::TextElement
    FalseClass
    Hash
    NilClass
    Proc
    String
        Amrita::SanitizedString
    TrueClass
Amrita::DictionaryData
Amrita::ExpandByMember
StandardError
    Amrita::HtmlParseError
RuntimeError
    Amrita::ModelMisMatch
Amrita::Node
Enumerable


NodeincludeNX
FormatterNode     <= ꂪۂB
NullNode
Element
TextElement
NodeArray
SpecialElement

=end
