
# -*- encoding:euc-jp -*-

# Web֥饦μθȡƤʤƤtextareaʤɤνλʤ
# ФʤʤդˡinputʤɤνλƤϤʤʤ

require "test/unit"
require "test/unit/ui/console/testrunner"

require "amrita/template"

class EmptyTagTest < Test::Unit::TestCase
  def setup
    @tags = %w(basefont br area link img param hr input col frame isindex base meta)
  end

  # λʤ
  def test1
    @tags.each {|t|
      tmpl = Amrita::TemplateText.new("<#{t}>")
      r = ""
      tmpl.expand(r, {})
      assert_equal("<#{t}>", r)
    }
  end

  # °ͤꤷƤ⡢λʤ
  def test2
    tmpl = Amrita::TemplateText.new '<input id="e" name="@n">'
    r = ""
    tmpl.expand(r, {:e => {:n => "foo"}})
    assert_equal('<input name="foo">', r)
  end

  # emptyǤʤϡλ뤳
  def test31
    tmpl = Amrita::TemplateText.new '<textarea id="hoge"></textarea>'
    r = ""
    tmpl.expand(r, {:hoge => ''})
    assert_equal('<textarea></textarea>', r)
  end

  # emptyƤꤷ硢̵뤹뤳
  def test32
    tmpl = Amrita::TemplateText.new '<input id="hoge" />'
    r = ""
    tmpl.expand(r, {:hoge => 'Yeah!'})
    assert_equal('<input>', r)
  end
end

if __FILE__ == $0
  Test::Unit::UI::Console::TestRunner.run(EmptyTagTest)
end
